Ruby master - Feature #3753

value of def-expr
08/28/2010 02:56 PM - usa (Usaku NAKAMURA)

Status: Closed
Priority: Normal

Assignee: usa (Usaku NAKAMURA)

Target version: 21.0

Description

=begin
RubyKaigill100000000000defl0Symbol0000000000O0?
gooooo

class Foo
private def foo()
#...

end

end

00ooooonoooooo
gooooo

Index: vm.c

—-vm.c (00000 29124)

+++vm.c (00000)

@@ -1893,7 +1893,7 @@ m_core_define_method(VALUE self, VALUE c
REWIND_CFP({

vm_define_method(GET_THREAD(), cbase, SYM2ID(sym), iseqval, 0, rb_vm_cref());
s

e return Qnil;
e return sym; }

static VALUE

@@ -1902,7 +1902,7 @@ m_core_define_singleton_method(VALUE sel
REWIND_CFP({

vm_define_method(GET_THREAD(), cbase, SYM2ID(sym), iseqval, 1, rb_vm_cref());
s

e return Qnil;
e return sym;}

static VALUE
=end

Related issues:
Related to Ruby master - Feature #6198: public/protected/private with attr_* Rejected

Associated revisions

Revision 0f0b60ea - 08/02/2013 02:58 PM - usa (Usaku NAKAMURA)

e vm.c (m_core_define_method, m_core_define_singleton_method): now
the value of def-expr is the Symbol of the name of the method, not
nil.
ref. [ruby-dev:42151] [Feature #3753]

o test/ruby/test_syntax.rb (TestSyntax#test_value_of def): test for
above changes.

01/25/2021 1/7




git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@42337 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 42337 - 08/02/2013 02:58 PM - usa (Usaku NAKAMURA)

e vm.c (m_core_define_method, m_core_define_singleton_method): now
the value of def-expr is the Symbol of the name of the method, not
nil.
ref. [ruby-dev:42151] [Feature #3753]

o test/ruby/test_syntax.rb (TestSyntax#test_value_of_def): test for
above changes.

Revision 42337 - 08/02/2013 02:58 PM - usa (Usaku NAKAMURA)

¢ vm.c (m_core_define_method, m_core_define_singleton_method): now
the value of def-expr is the Symbol of the name of the method, not
nil.
ref. [ruby-dev:42151] [Feature #3753]

e test/ruby/test_syntax.rb (TestSyntax#test_value_of_def): test for
above changes.

Revision 42337 - 08/02/2013 02:58 PM - usa (Usaku NAKAMURA)

e vm.c (m_core_define_method, m_core_define_singleton_method): now
the value of def-expr is the Symbol of the name of the method, not
nil.
ref. [ruby-dev:42151] [Feature #3753]

e test/ruby/test_syntax.rb (TestSyntax#test_value_of def): test for
above changes.

Revision 42337 - 08/02/2013 02:58 PM - usa (Usaku NAKAMURA)

e vm.c (m_core_define_method, m_core_define_singleton_method): now
the value of def-expr is the Symbol of the name of the method, not
nil.
ref. [ruby-dev:42151] [Feature #3753]

o test/ruby/test_syntax.rb (TestSyntax#test_value_of def): test for
above changes.

Revision 42337 - 08/02/2013 02:58 PM - usa (Usaku NAKAMURA)

¢ vm.c (m_core_define_method, m_core_define_singleton_method): now
the value of def-expr is the Symbol of the name of the method, not
nil.
ref. [ruby-dev:42151] [Feature #3753]

e test/ruby/test_syntax.rb (TestSyntax#test_value_of_def): test for
above changes.
Revision 42337 - 08/02/2013 02:58 PM - usa (Usaku NAKAMURA)

e vm.c (m_core_define_method, m_core_define_singleton_method): now
the value of def-expr is the Symbol of the name of the method, not
nil.
ref. [ruby-dev:42151] [Feature #3753]

o test/ruby/test_syntax.rb (TestSyntax#test_value_of_def): test for
above changes.

Revision ccd5c3dd - 08/02/2013 09:57 PM - usa (Usaku NAKAMURA)

e parse.y (value_expr_gen): now NODE_DEFN and NODE_DEFS are not void value expressions.

pass tests with chkbuild. ref. [Feature #3753]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@42347 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 42347 - 08/02/2013 09:57 PM - usa (Usaku NAKAMURA)

e parse.y (value_expr_gen): now NODE_DEFN and NODE_DEFS are not void value expressions.

pass tests with chkbuild. ref. [Feature #3753]

Revision 42347 - 08/02/2013 09:57 PM - usa (Usaku NAKAMURA)

e parse.y (value_expr_gen): now NODE_DEFN and NODE_DEFS are not void value expressions.

pass tests with chkbuild. ref. [Feature #3753]

Revision 42347 - 08/02/2013 09:57 PM - usa (Usaku NAKAMURA)

® parse.y (value_expr_gen): now NODE_DEFN and NODE_DEFS are not void value expressions.

pass tests with chkbuild. ref. [Feature #3753]

Revision 42347 - 08/02/2013 09:57 PM - usa (Usaku NAKAMURA)

e parse.y (value_expr_gen): now NODE_DEFN and NODE_DEFS are not void value expressions.

pass tests with chkbuild. ref. [Feature #3753]

Revision 42347 - 08/02/2013 09:57 PM - usa (Usaku NAKAMURA)

e parse.y (value_expr_gen): now NODE_DEFN and NODE_DEFS are not void value expressions.

pass tests with chkbuild. ref. [Feature #3753]

Revision 42347 - 08/02/2013 09:57 PM - usa (Usaku NAKAMURA)

® parse.y (value_expr_gen): now NODE_DEFN and NODE_DEFS are not void value expressions.

pass tests with chkbuild. ref. [Feature #3753]

Revision e34fac64 - 08/03/2013 07:57 AM - naruse (Yui NARUSE)
Fix test failure to follow r42347 ref #3753

git-svn-id: svn+ssh:/ci.ruby-lang.org/ruby/trunk@42352 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 42352 - 08/03/2013 07:57 AM - naruse (Yui NARUSE)
Fix test failure to follow r42347 ref #3753

Revision 42352 - 08/03/2013 07:57 AM - naruse (Yui NARUSE)
Fix test failure to follow r42347 ref #3753
Revision 42352 - 08/03/2013 07:57 AM - naruse (Yui NARUSE)
Fix test failure to follow r42347 ref #3753

Revision 42352 - 08/03/2013 07:57 AM - naruse (Yui NARUSE)
Fix test failure to follow r42347 ref #3753

Revision 42352 - 08/03/2013 07:57 AM - naruse (Yui NARUSE)
Fix test failure to follow r42347 ref #3753

Revision 42352 - 08/03/2013 07:57 AM - naruse (Yui NARUSE)
Fix test failure to follow r42347 ref #3753

Revision a28d1eff - 08/14/2013 05:35 AM - usa (Usaku NAKAMURA)

e proc.c (rb_mod_define_method): now they return the symbols of the

defined methods, not the methods/procs themselves.
[ruby-dev:42151] [Feature #3753]

¢ NEWS: documents about above change and def-expr (see r42337).

e test/ruby/test_module.rb: tests about above change.

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@42551 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 42551 - 08/14/2013 05:35 AM - usa (Usaku NAKAMURA)

e proc.c (rb_mod_define_method): now they return the symbols of the

defined methods, not the methods/procs themselves.
[ruby-dev:42151] [Feature #3753]

e NEWS: documents about above change and def-expr (see r42337).

e test/ruby/test_module.rb: tests about above change.

Revision 42551 - 08/14/2013 05:35 AM - usa (Usaku NAKAMURA)

e proc.c (rb_mod_define_method): now they return the symbols of the

defined methods, not the methods/procs themselves.
[ruby-dev:42151] [Feature #3753]

e NEWS: documents about above change and def-expr (see r42337).

¢ test/ruby/test_module.rb: tests about above change.

Revision 42551 - 08/14/2013 05:35 AM - usa (Usaku NAKAMURA)

e proc.c (rb_mod_define_method): now they return the symbols of the

defined methods, not the methods/procs themselves.
[ruby-dev:42151] [Feature #3753]

o NEWS: documents about above change and def-expr (see r42337).

e test/ruby/test_module.rb: tests about above change.

01/25/2021

4/7



Revision 42551 - 08/14/2013 05:35 AM - usa (Usaku NAKAMURA)

e proc.c (rb_mod_define_method): now they return the symbols of the
defined methods, not the methods/procs themselves.
[ruby-dev:42151] [Feature #3753]

¢ NEWS: documents about above change and def-expr (see r42337).

e test/ruby/test_module.rb: tests about above change.

Revision 42551 - 08/14/2013 05:35 AM - usa (Usaku NAKAMURA)

e proc.c (rb_mod_define_method): now they return the symbols of the
defined methods, not the methods/procs themselves.
[ruby-dev:42151] [Feature #3753]

e NEWS: documents about above change and def-expr (see r42337).

e test/ruby/test_module.rb: tests about above change.

Revision 42551 - 08/14/2013 05:35 AM - usa (Usaku NAKAMURA)

e proc.c (rb_mod_define_method): now they return the symbols of the
defined methods, not the methods/procs themselves.
[ruby-dev:42151] [Feature #3753]

o NEWS: documents about above change and def-expr (see r42337).

e test/ruby/test_module.rb: tests about above change.

History

#1 - 08/31/2010 05:01 PM - usa (Usaku NAKAMURA)
- Category set to core
- Status changed from Open to Assigned

- Assignee set to matz (Yukihiro Matsumoto)

=begin

=end

#2 - 08/31/2010 05:11 PM - mrkn (Kenta Murata)

=begin
+1
=end

#3 - 10/27/2012 11:58 PM - yhara (Yutaka HARA)
- Description updated

- Target version set to 2.6

#4 - 06/06/2013 12:23 PM - usa (Usaku NAKAMURA)

- Target version changed from 2.6 to 2.1.0

RubyKaigill 1000000000000000000O00000DODOD
#5 - 07/27/2013 01:45 PM - matz (Yukihiro Matsumoto)
- Assignee changed from matz (Yukihiro Matsumoto) to usa (Usaku NAKAMURA)

We accept this change for 2.1 in the developers' meeting on 2013-07-27. We also think define_method() should return symbols as well.

Matz.

#6 - 08/02/2013 11:58 PM - usa (Usaku NAKAMURA)
- Status changed from Assigned to Closed

- % Done changed from 0 to 100

This issue was solved with changeset r42337.
Usaku, thank you for reporting this issue.

Your contribution to Ruby is greatly appreciated.
May Ruby be with you.

e vm.c (m_core_define_method, m_core_define_singleton_method): now
the value of def-expr is the Symbol of the name of the method, not
nil.
ref. [ruby-dev:42151] [Feature #3753]

e test/ruby/test_syntax.rb (TestSyntax#test_value_of def): test for
above changes.

#7 - 08/03/2013 12:04 AM - usa (Usaku NAKAMURA)
- Status changed from Closed to Assigned

- % Done changed from 100 to 50

=begin
“define_method()" 00000000000000000Module#define_method 0000000000000000000D00D
10000000oo0oonoonDoooonoonnoOOOnn

Index: proc.c

--- proc.c (10000 42336)

+++ proc.c (10000)

@@ -1510,7 +1510,7 @@ rb_mod_define_method(int argc, VALUE *ar
rb_raise(rb_eTypeError, "wrong argument type (expected Proc/Method)");

}

e return body;
e return ID2SYM(id); }

/*
=end

#8 - 08/03/2013 06:57 AM - usa (Usaku NAKAMURA)

- Status changed from Assigned to Closed

- % Done changed from 50 to 100

This issue was solved with changeset r42347.
Usaku, thank you for reporting this issue.

Your contribution to Ruby is greatly appreciated.
May Ruby be with you.

e parse.y (value_expr_gen): now NODE_DEFN and NODE_DEFS are not void value expressions. get rid of wrong warning with -w, and make to
pass tests with chkbuild. ref. [Feature #3753]

#9 - 08/04/2013 02:46 AM - usa (Usaku NAKAMURA)
- Status changed from Closed to Assigned

- % Done changed from 100 to 50
#10 - 08/09/2013 08:34 PM - matz (Yukihiro Matsumoto)

Yes, | think Module#define_method should return a symbol as def statement does.

Matz.

#11 - 08/14/2013 02:35 PM - usa (Usaku NAKAMURA)
- Status changed from Assigned to Closed

- % Done changed from 50 to 100

This issue was solved with changeset r42551.
Usaku, thank you for reporting this issue.

Your contribution to Ruby is greatly appreciated.
May Ruby be with you.

e proc.c (rb_mod_define_method): now they return the symbols of the
defined methods, not the methods/procs themselves.
[ruby-dev:42151] [Feature #3753]

o NEWS: documents about above change and def-expr (see r42337).

e test/ruby/test_module.rb: tests about above change.
